<?php
  /*
* Project:     Morgdkp2 eqdkp plus plug-in
* License:     Creative Commons - Attribution-Noncommercial-Share Alike 3.0 Unported
* Link:    http://creativecommons.org/licenses/by-nc-sa/3.0/
* -----------------------------------------------------------------------
* Began:       2013
* -----------------------------------------------------------------------
* @author      BlueWarlord
* @copyright   2013-
* Based upon the EQdkp-Plus epgpimport plug-in and Morgalm's original morgdkp 2 plug-in for eqkdp plus 0.6
*/


if(!defined('EQDKP_INC')) {
  header('HTTP/1.0 Not Found');
  exit;
}
$eqdkp_root_path = './../../../';
include_once($eqdkp_root_path.'common.php');

if(!class_exists('morgdkp2_functions')) {
	class morgdkp2_functions extends gen_class {
		public static function __shortcuts() {
			$shortcuts = array('user', 'in', 'tpl', 'core', 'pdc', 'pdh', 'pm', 'config', 'html', 'db', 'logs');
			return array_merge(parent::$shortcuts, $shortcuts);
		}  
		
		public function __construct() {
			$this->pdl = registry::register('plus_debug_logger'); 
			$this->user->check_auth('a_morgdkp2_import');
		}
		
		public function array_merge_keys($arr1, $arr2) {
			foreach($arr2 as $k=>$v) {
				if (!array_key_exists($k, $arr1)) { 
			   		$arr1[$k]=$v;
				}
				else { 
			    		if (is_array($v)) { 
			        		$arr1[$k]=$this->array_merge_keys($arr1[$k], $arr2[$k]);
			    		}
				}
			}
			return $arr1;
		}

		
		public function Arraydiff($arr1, $arr2) {
			$diff = array_diff_assoc($arr1, $arr2);
			foreach ($diff as $key => $value) {
				$arr2[$key] = $value;
			}
			return $arr2;
		}

		
		public function gen_group_key($part1, $part2, $part3) {
			// Normalize data
			$part1 = htmlspecialchars(stripslashes($part1));
			$part2 = htmlspecialchars(stripslashes($part2));
			$part3 = htmlspecialchars(stripslashes($part3));
		        
			// Get the first 10-11 digits of each md5 hash
			$part1 = substr(md5($part1), 0, 10);
			$part2 = substr(md5($part2), 0, 11);
			$part3 = substr(md5($part3), 0, 11);
		        
			// Group the hashes together and create a new hash based on uniqid()
			$group_key = $part1 . $part2 . $part3;
			$group_key = md5(uniqid($group_key));
			return $group_key;
		}
	
		public function FetchMember($name) {
			$sql = "SELECT member_id FROM __members WHERE member_name = '$name'";
			$result = $this->db->query($sql);
			while ($row = $this->db->fetch_record($result) ){
				$temp = $row['member_id'];          
			}
			//$this->db->free_result($result);                
			return $temp;
		} 
		
		public function FetchEvent($name, $value, $pool) {
			$sql = "SELECT event_id FROM __events WHERE event_name = '$name'";
			$result = $this->db->query($sql);
			while ($row = $this->db->fetch_record($result) ){
				$temp = $row['event_id'];          
			}
			//$this->db->free_result($result);                
			if (!$temp) $temp = $this->CreateEvent($name, $value, $pool);
			return $temp;
		} 
		
		public function FetchPoolID($name) {
			$sql = "SELECT multidkp_id FROM __multidkp WHERE multidkp_name = '$name'";
			$result = $this->db->query($sql);
			while ($row = $this->db->fetch_record($result) ){
				$temp = $row['multidkp_id'];          
			}
			//$this->db->free_result($result);                
			return $temp;
		} 
		
		public function CheckAlias($names) {
			$aliases = $this->FetchAliasSimple();
			if (empty($aliases) || empty($names) ) return $names;
			foreach ($names as $num => $alt) {
				$alt = rtrim($alt);
				$alt = ucwords($alt);
				foreach ($aliases as $alias => $member) {
					if ($alt == $alias) {
						$names[$num] = $member;
						break;
					}
				}
			}
			return $names;
		}  // End of CheckAlias()
		
		public function FetchAllRanks() {
			$sql = "SELECT rank_id, rank_name FROM __member_ranks";
			$result = $this->db->query($sql);
	    		$temp = array();
			while ($row = $this->db->fetch_record($result)) {
				$rankid = $row["rank_id"];
				if ($rankid != 0) $temp[$rankid] = $row["rank_name"];
			}
			//$this->db->free_result($result);
			return $temp;
		
		}
		
		public function GetDKPPools() {
			$sql = "SELECT * FROM __multidkp";
			$result = $this->db->query($sql);
	    		$temp = array();
			while ($row = $this->db->fetch_record($result)) {
				$temp[$row['multidkp_id']] = $row['multidkp_name'];
			}
			//$this->db->free_result($result);
			return $temp;
		
		}
		
		public function FetchAllEvents() {
			$temp = array();
			$sql = "SELECT event_id, event_name, event_value FROM __events ORDER BY event_name";
			$result = $this->db->query($sql);
		    	while ($row = $this->db->fetch_record($result)) {
		    		$temp[$row['event_id']] = array('event_value'=>$row['event_value'], 'event_name'=>$row['event_name']);
		    	}
		    	//$this->db->free_result($result);
		    	return $temp;
		}
		
		public function FetchAliasSimple() {
			$temp = array();
			$sql = "SELECT alias_id, alias_member_id, alias_name, member_id, member_name FROM __ctrt_aliases, __members WHERE member_id = alias_member_id";
			$result = $this->db->query($sql);
			while ($row = $this->db->fetch_record($result)) {
				$temp[$row["alias_name"]] = $row["member_name"];
			}
			//$this->db->free_result($result);
			return $temp;
		}

		public function FetchAliases($name) {
			$temp = array();
			$sql = "SELECT alias_id, alias_name, alias_member_id, member_name, member_id FROM __ctrt_aliases, __members WHERE member_id = alias_member_id AND member_name = '$name'";
		    	$result = $this->db->query($sql);				
			while ($row = $this->db->fetch_record($result)) {
				$temp[] = array("alias_id"=>$row["alias_id"],
	    			            	"alias_name"=>stripslashes($row["alias_name"]),
						"alias_member_id"=>$row["alias_member_id"],
						"member_name"=>stripslashes($row["member_name"]),
						"member_id"=>$row["member_id"]);
			}
			//$this->db->free_result($result);
			return $temp;
		} 
		
		public function AddMultiAdjustment($name, $change, $key) {
			$user = $this->user->data['username'];
			$time = time();
			$memberid = $this->FetchMember($name);
			$this->pdl->log("morgdkp2", 'Multi adjustment memberid='.$memberid);
	    		$name = rtrim($name);
			if (!$memberid) {
				$newmember = array(	'member_name'=>"'" . addslashes($name) . "'",
							'member_class_id'=>'1',
							'member_race_id'=>'1');
				$this->AddNEWMember($name, $newmember);
				$memberid = $this->FetchMember($name);
			}
			//$this->db->free_result($result);
			$result = $this->db->query("INSERT INTO __adjustments :params", array(	'adjustment_value' => $change['value'], 
												'adjustment_date' => $time,
												'member_id' => $memberid,
												'adjustment_reason' => $change['event'],
												'adjustment_added_by' => $user,
												'adjustment_group_key' => $key,
												'event_id' => $change['event_id']));	
			if (!$result) {
	    			$this->pdl->log("morgdkp2", 'Add multi adjustment failed!');
	    			return false;
	    		}
			$this->pdl->log("morgdkp2", 'Add multi adjustment:'.$this->pdl->format_array($change));
			return true;
		}

		public function AddNEWMember($membername, $data) {
			$user = $this->user->data['username'];
			$sql = "INSERT INTO __members (" . join(',', array_keys($data)) . ") VALUES (" . join(',', array_values($data)) . ")";
	    		$result = $this->db->query($sql);
			if (!$result) {
	    			$this->pdl->log("morgdkp2", 'Add new member failed!');
			} else {
				$log_action = array(	'header' => '{L_ACTION_MEMBER_ADDED}',
							'{L_NAME}' => addslashes($membername),
							'{L_LEVEL}' => $data['member_level'],
							'{L_RACE_ID}' => $otherdata['race'],
							'{L_CLASS_ID}' => $otherdata['class'],
							'{L_ADDED_BY}' => addslashes($user));
				$this->logs->add($log_action['header'], $log_action, true, 'morgdkp2');
				$this->pdl->log("morgdkp2", 'Add new member:'.$this->pdl->format_array($data));
				return true;
			}
		}

		public function CreateEvent($eventname, $eventvalue, $eventpool) {
			$user = $this->user->data['username'];
			$result = $this->db->query("INSERT INTO __events :params", array(	'event_name' => $eventname, 
												'event_value' => $eventvalue,
												'event_icon' => 'fireland5.png',
												'event_added_by' => $user));	
			if (!$result) {
	    			$this->pdl->log("morgdkp2", 'Create event failed!');
			} else {
				$id = $this->db->insert_id();
				$multiid = $this->FetchPoolID($eventpool);
				if (!$multiid) $multiid = 1;
				$result = $this->db->query("INSERT INTO __multidkp2event :params", array('multidkp2event_multi_id' => $multiid, 'multidkp2event_event_id' => $id));	
				$log_action = array(	'header' => '{L_ACTION_EVENT_ADDED}',
							'id' => $id,
							'{L_NAME}' => addslashes($eventname),
							'{L_VALUE}' => $eventvalue,
							'{L_ADDED_BY}' => $user);
				$this->logs->add($log_action['header'], $log_action, true, 'morgdkp2');
				$this->pdl->log("morgdkp2", 'Create event:'.$eventname);
				//$this->pdh->put('event', 'update_event', array($id, $eventname, $eventvalue, 'fireland5.png'));
				return $id;
			}
			return false;
		}


  } // End of morgdkp2_functions class
} // End of if

if(version_compare(PHP_VERSION, '5.3.0', '<')) registry::add_const('short_morgdkp2_functions', morgdkp2_functions::__shortcuts());
registry::register('morgdkp2_functions');

?>
